'use strict'
############################################################
#
# User정보를 작성하는 class
#
# 샘플데이터 작성용 유저 클래스 
window.User = class User
  # 지불 기반액
  @basePayment: d3.random.normal(500)
  # 기본속성 ([rate, payFactor])
  @attributes:
    gender:
      "남성": [0.6, 0.2], "여성": [0.4, 0.4]
    age:
      "10대": [0.05, 0.3], "20대": [0.2, 0.2]
      "30대": [0.3, 0.3], "40대": [0.3, 0.5]
      "50대": [0.1, 0.7], "60대": [0.05, 0.7]
    job:
      "기타": [0.05, 0.1], "회사원": [0.4, 0.3]
      "전업주부": [0.05, 0.6], "자영업": [0.1, 0.3]
      "学生": [0.15, 0.3], "무직": [0.1, 0.1]
      "프리랜서": [0.15, 0.1]
  # 캠페인 
  @campaigns:
    "캠페인 1": [0.25, 0.2], "캠페인 2": [0.25, 0.4]
    "캠페인 3": [0.25, 0.1], "캠페인 4": [0.25, 0.5]

  constructor: ()->
    # 캠페인 결정 
    [campaign, payFactor] = @_selectAttr(User.campaigns)
    @campaign = campaign
    @payFactor = payFactor

    # 각종 속성 결정 
    for attrType, attrs of User.attributes
      [attr, payFactor] = @_selectAttr(attrs)
      this[attrType] = attr
      @payFactor += payFactor

    @payment = @payFactor * User.basePayment()

  # 선택지에서 하나를 선택하는 메소드 
  _selectAttr: (attrs)->
    r = Math.random()
    cumulate = 0
    for attr, [prob, payFactor] of attrs
      cumulate += prob
      if r < cumulate
        return [attr, payFactor]
